diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 19be7b340..8859082fb 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.player.LocalPlayer;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.ArtType;
@@ -34,6 +35,7 @@ public abstract class PlayerController {
 	//Called when the mouse is clicked and about 5 times per second while the button is held down
 	//Repeat is false when the mouse was clicked this frame
 	public void startDestroyBlock(int x, int y, int z, Side side, double xHit, double yHit, boolean repeat) {
+		if (mc.thePlayer.getHeldObject() != null) return;
 		if (!mc.thePlayer.getGamemode().canInteract()) return;
 		if(!mc.thePlayer.getGamemode().doBlockBreakingAnim()) {
 			swingItem(true);
@@ -63,7 +65,7 @@ public abstract class PlayerController {
 	
 	//Called 20 times per second when the mouse button is held and blocks are targeted
 	public void continueDestroyBlock(int x, int y, int z, Side side, double xHit, double yHit) {
-		if(!mc.thePlayer.getGamemode().doBlockBreakingAnim() || !mc.thePlayer.getGamemode().canInteract()) {
+		if(!mc.thePlayer.getGamemode().doBlockBreakingAnim() || !mc.thePlayer.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) {
 			return;
 		}
 		
@@ -144,7 +146,7 @@ public abstract class PlayerController {
 	}
 
 	public boolean destroyBlock(int x, int y, int z, Side side, Player player) {
-		if (!player.getGamemode().canInteract()) return false;
+		if (!player.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return false;
 		setMineBlock(null, null, null);
 		World world = mc.theWorld;
 		Block block = Block.getBlock(world.getBlockId(x, y, z));
@@ -179,7 +181,7 @@ public abstract class PlayerController {
 	}
 	
 	protected void hitBlock(int x, int y, int z, Side side, double xHit, double yHit) {
-		if (!mc.thePlayer.getGamemode().canInteract()) return;
+		if (!mc.thePlayer.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return;
 		mc.theWorld.onBlockHit(mc.thePlayer, x, y, z, side);
 		
 		Block block = Block.getBlock(mc.theWorld.getBlockId(x, y, z));
@@ -222,9 +224,9 @@ public abstract class PlayerController {
 		int prevStackSize = stack.stackSize;
 		ItemStack newItemStack = stack.useItemRightClick(world, player);
 		if(newItemStack != stack || newItemStack.stackSize != prevStackSize) {
-			player.inventory.mainInventory[player.inventory.currentItem] = newItemStack;
+			player.inventory.mainInventory[player.inventory.getCurrentItemIndex()] = newItemStack;
 			if(newItemStack == null || newItemStack.stackSize <= 0) {
-				player.inventory.mainInventory[player.inventory.currentItem] = null;
+				player.inventory.mainInventory[player.inventory.getCurrentItemIndex()] = null;
 			}
 			return true;
 		}
@@ -253,17 +255,38 @@ public abstract class PlayerController {
 	public boolean useItemOn(Player player, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
 	{
 		if (!player.getGamemode().canInteract()) return false;
-		int i1 = world.getBlockId(blockX, blockY, blockZ);
-		if (!player.isSneaking() || player.inventory.getCurrentItem() == null) {
-			if (i1 > 0 && Block.blocksList[i1].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
-				return true;
+		int blockId = world.getBlockId(blockX, blockY, blockZ);
+		if (player.getHeldObject() == null) {
+			if (player.isSneaking() && itemstack == null) { // If crouched and hand empty try to pickup block entity
+				BlockEntity blockEntity = world.getBlockEntity(blockX, blockY, blockZ);
+				if (blockEntity != null && blockEntity.canBeCarried(world, player)) {
+					player.setHeldObject(blockEntity.pickup(world, player));
+					return true;
+				}
+			}
+			if (!player.isSneaking() || itemstack == null) {  // If standing or hand empty perform block right click method
+				if (blockId > 0 && Block.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
+					return true;
+				}
+			}
+			if (itemstack == null) { // No stack do nothing
+				return false;
+			} else { // Use itemstack
+				return itemstack.useItem(player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 			}
-		}
-		if (itemstack == null) {
-			return false;
 		} else {
-			return itemstack.useItem(player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+			if (!player.isSneaking()) {  // If standing or hand empty perform block right click method
+				if (blockId > 0 && Block.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
+					return true;
+				}
+			}
+			boolean didPlace = player.getHeldObject().tryPlace(world, player, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+			if (didPlace) {
+				player.setHeldObject(null);
+			}
+			return didPlace;
 		}
+
 	}
 
 	public Player createPlayer(World world) {
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index 8e9290846..3a00c9c1d 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -56,7 +56,7 @@ public class PlayerControllerMP extends PlayerController {
 	
 	@Override
 	protected void syncCurrentPlayItem() {
-		int i = mc.thePlayer.inventory.currentItem;
+		int i = mc.thePlayer.inventory.getCurrentItemIndex();
 		if (i != currentItem) {
 			currentItem = i;
 			netHandler.addToSendQueue(new SetCarriedItemPacket(currentItem));
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java b/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
index 05e609360..d4307c23b 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
@@ -15,7 +15,7 @@ public class PlayerControllerSP extends PlayerController {
 
 	@Override
 	public boolean destroyBlock(int x, int y, int z, Side side, Player player) {
-		if (!player.getGamemode().canInteract()) return false;
+		if (!player.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return false;
 		int id = mc.theWorld.getBlockId(x, y, z);
 		int meta = mc.theWorld.getBlockMetadata(x, y, z);
 		BlockEntity blockEntity = mc.theWorld.getBlockEntity(x, y, z);
diff --git a/src/main/java/net/minecraft/client/render/ItemRenderer.java b/src/main/java/net/minecraft/client/render/ItemRenderer.java
index bd88d605e..7dd27c1e0 100644
--- a/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -89,28 +89,38 @@ public class ItemRenderer
         		brightness = mc.theWorld.getLightBrightness(MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z));
         	}
             GL11.glColor4f(brightness, brightness, brightness, 1.0f);
-            float f6 = 0.8F;
-            float swingProgress = player.getSwingProgress(partialTick);
-            float f14 = MathHelper.sin(swingProgress * MathHelper.PI);
-            float f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
-            GL11.glTranslatef(-f18 * 0.3F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.4F, -f14 * 0.4F);
-            GL11.glTranslatef(0.8F * f6, -0.75F * f6 - (1.0F - equipProgress) * 0.6F, -0.9F * f6);
-            GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
-            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-            f14 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
-            f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
-            GL11.glRotatef(f18 * 70F, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(-f14 * 20F, 0.0F, 0.0F, 1.0F);
-            mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
-            GL11.glTranslatef(-1F, 3.6F, 3.5F);
-            GL11.glRotatef(120F, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(200F, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
-            GL11.glScalef(1.0F, 1.0F, 1.0F);
-            GL11.glTranslatef(5.6F, 0.0F, 0.0F);
             EntityRenderer<? extends Entity> render = EntityRenderDispatcher.instance.getRenderer(mc.thePlayer);
-            PlayerRenderer renderplayer = (PlayerRenderer)render;
-            renderplayer.drawFirstPersonHand(mc.thePlayer, false);
+            PlayerRenderer playerRenderer = (PlayerRenderer)render;
+            if (player.getHeldObject() == null) {
+                float f6 = 0.8F;
+                float swingProgress = player.getSwingProgress(partialTick);
+                float f14 = MathHelper.sin(swingProgress * MathHelper.PI);
+                float f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
+                GL11.glTranslatef(-f18 * 0.3F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.4F, -f14 * 0.4F);
+                GL11.glTranslatef(0.8F * f6, -0.75F * f6 - (1.0F - equipProgress) * 0.6F, -0.9F * f6);
+                GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
+                GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+                f14 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
+                f18 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
+                GL11.glRotatef(f18 * 70F, 0.0F, 1.0F, 0.0F);
+                GL11.glRotatef(-f14 * 20F, 0.0F, 0.0F, 1.0F);
+                mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
+                GL11.glTranslatef(-1F, 3.6F, 3.5F);
+                GL11.glRotatef(120F, 0.0F, 0.0F, 1.0F);
+                GL11.glRotatef(200F, 1.0F, 0.0F, 0.0F);
+                GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
+                GL11.glScalef(1.0F, 1.0F, 1.0F);
+                GL11.glTranslatef(5.6F, 0.0F, 0.0F);
+                playerRenderer.drawFirstPersonHand(mc.thePlayer, false);
+            } else {
+                GL11.glPushMatrix();
+                float swingProgress = player.getSwingProgress(partialTick);
+                GL11.glTranslatef(0, MathHelper.sin(swingProgress * MathHelper.PI * 2 - MathHelper.PI/2)/33f, 0); // Bounces the held object up on swing
+                GL11.glScalef(1, -1f, 1); // Flips y axis because entities are flipped vertically ig
+                GL11.glRotatef(-MathHelper.sin(swingProgress * MathHelper.PI * 2) * 5f, 1, 0, 0); // Slightly rotates the object when swung
+                playerRenderer.drawHeldObject(mc.thePlayer, partialTick);
+                GL11.glPopMatrix();
+            }
         }
         GL11.glPopMatrix();
         GL11.glDisable(GL12.GL_RESCALE_NORMAL);
@@ -273,7 +283,7 @@ public class ItemRenderer
         oHeight = height;
         LocalPlayer entityplayersp = mc.thePlayer;
         ItemStack itemstack = entityplayersp.inventory.getCurrentItem();
-        boolean flag = lastSlot == entityplayersp.inventory.currentItem && itemstack == itemToRender;
+        boolean flag = lastSlot == entityplayersp.inventory.getCurrentItemIndex() && itemstack == itemToRender;
         if(itemToRender == null && itemstack == null)
         {
             flag = true;
@@ -298,7 +308,7 @@ public class ItemRenderer
         if(height < 0.1F)
         {
             itemToRender = itemstack;
-            lastSlot = entityplayersp.inventory.currentItem;
+            lastSlot = entityplayersp.inventory.getCurrentItemIndex();
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/RedstoneWireBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/RedstoneWireBlockModel.java
index 0b7471b8c..74720ad25 100644
--- a/src/main/java/net/minecraft/client/render/block/model/RedstoneWireBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/RedstoneWireBlockModel.java
@@ -51,32 +51,32 @@ public class RedstoneWireBlockModel<T extends Block> extends StandardBlockModel<
         float blue = color.getBlue() / 255.0f;
 
         tessellator.setColorOpaque_F(brightness * red, brightness * green, brightness * blue);
-        boolean west = RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x - 1, y, z, 1) || !renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x - 1, y - 1, z, -1);
-        boolean east = RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x + 1, y, z, 3) || !renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x + 1, y - 1, z, -1);
-        boolean north = RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y, z - 1, 2) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y - 1, z - 1, -1);
-        boolean south = RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y, z + 1, 0) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y - 1, z + 1, -1);
+        boolean west = RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x - 1, y, z, 1) || !renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x - 1, y - 1, z, -1);
+        boolean east = RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x + 1, y, z, 3) || !renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x + 1, y - 1, z, -1);
+        boolean north = RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x, y, z - 1, 2) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x, y - 1, z - 1, -1);
+        boolean south = RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x, y, z + 1, 0) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x, y - 1, z + 1, -1);
         boolean westUp = false;
         boolean eastUp = false;
         boolean northUp = false;
         boolean southUp = false;
         if(!renderBlocks.blockAccess.isBlockOpaqueCube(x, y + 1, z))
         {
-            if(renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x - 1, y + 1, z, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x - 1, y + 1, z, -1))
             {
                 west = true;
                 westUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x + 1, y + 1, z, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x + 1, y + 1, z, -1))
             {
                 east = true;
                 eastUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y + 1, z - 1, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x, y + 1, z - 1, -1))
             {
                 north = true;
                 northUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && RedstoneWireBlock.isPowerProviderOrWire(renderBlocks.blockAccess, x, y + 1, z + 1, -1))
+            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && RedstoneWireBlock.shouldConnectTo(renderBlocks.blockAccess, x, y + 1, z + 1, -1))
             {
                 south = true;
                 southUp = true;
diff --git a/src/main/java/net/minecraft/client/render/blockentity/FlagBlockEntityRenderer.java b/src/main/java/net/minecraft/client/render/blockentity/FlagBlockEntityRenderer.java
index 2fbce2cec..d8bd8d881 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/FlagBlockEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/FlagBlockEntityRenderer.java
@@ -17,7 +17,7 @@ public class FlagBlockEntityRenderer extends BlockEntityRenderer<FlagBlockEntity
 	public final Minecraft mc = Minecraft.getMinecraft(this);
     private final FlagModel flagModel;
     private final FlagModel flagModelMirrored;
-    private FlagRenderer flagRenderer = null;
+    private static FlagRenderer flagRenderer = null;
     
     public FlagBlockEntityRenderer()
     {
@@ -42,13 +42,14 @@ public class FlagBlockEntityRenderer extends BlockEntityRenderer<FlagBlockEntity
     private long lastTick = 0;
     public void doRender(FlagBlockEntity flagBlockEntity, double x, double y, double z, float partialTick, boolean shortPole, float windDirection, float windIntensity)
     {
+        World theWorld = Minecraft.getMinecraft(this).theWorld;
         if (flagRenderer == null)
         {
             flagRenderer = new FlagRenderer(renderDispatcher.textureManager);
         }
 
-        if (flagBlockEntity.worldObj.getWorldTime() != lastTick) {
-            lastTick = flagBlockEntity.worldObj.getWorldTime();
+        if (theWorld.getWorldTime() != lastTick) {
+            lastTick = theWorld.getWorldTime();
             flagRenderer.tick();
         }
         
diff --git a/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java b/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
index dac770d19..eaf652b09 100644
--- a/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
@@ -24,10 +24,10 @@ public class ArmoredZombieRenderer extends BipedRenderer<ZombieArmoredMob>
         model.head.visible = renderPass == 0;
         model.hair.visible = renderPass == 0;
         model.body.visible = renderPass == 1 || renderPass == 2;
-        model.arm0.visible = renderPass == 1;
-        model.arm1.visible = renderPass == 1;
-        model.leg0.visible = renderPass == 2 || renderPass == 3;
-        model.leg1.visible = renderPass == 2 || renderPass == 3;
+        model.armRight.visible = renderPass == 1;
+        model.armLeft.visible = renderPass == 1;
+        model.legRight.visible = renderPass == 2 || renderPass == 3;
+        model.legLeft.visible = renderPass == 2 || renderPass == 3;
 
         // Disable armor pieces depending on health
         int[] armorBreakPoints = zombie.getArmorBreakPoints();
@@ -60,19 +60,19 @@ public class ArmoredZombieRenderer extends BipedRenderer<ZombieArmoredMob>
         else if (piece == 1)
         {
             modelArmorChestplate.body.visible = false;
-            modelArmorChestplate.arm1.visible = false;
-            modelArmorChestplate.arm0.visible = false;
+            modelArmorChestplate.armLeft.visible = false;
+            modelArmorChestplate.armRight.visible = false;
         }
         else if (piece == 2)
         {
             modelArmor.body.visible = false;
-            modelArmor.leg1.visible = false;
-            modelArmor.leg0.visible = false;
+            modelArmor.legLeft.visible = false;
+            modelArmor.legRight.visible = false;
         }
         else if (piece == 3)
         {
-            modelArmorChestplate.leg1.visible = false;
-            modelArmorChestplate.leg0.visible = false;
+            modelArmorChestplate.legLeft.visible = false;
+            modelArmorChestplate.legRight.visible = false;
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/entity/BipedRenderer.java b/src/main/java/net/minecraft/client/render/entity/BipedRenderer.java
index 590cfab6e..6adaeb592 100644
--- a/src/main/java/net/minecraft/client/render/entity/BipedRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/BipedRenderer.java
@@ -26,7 +26,7 @@ public class BipedRenderer<T extends Mob> extends MobRenderer<T>
 		ItemStack itemstack = entity.getHeldItem();
 		if(itemstack != null) {
 			GL11.glPushMatrix();
-			modelBipedMain.arm0.translateTo(0.0625F);
+			modelBipedMain.armRight.translateTo(0.0625F);
 			ItemModelDispatcher.getInstance().getDispatch(itemstack.getItem()).renderItemThirdPerson(Tessellator.instance, renderDispatcher.itemRenderer, entity, itemstack, true);
 			GL11.glPopMatrix();
 		}
